<template>
  <q-page padding>
    <q-toolbar class="bg-blue-grey text-white shadow-2 rounded-borders">
      Gestion de Jobs:
    </q-toolbar>

    <q-card class="q-mt-sm">
      <q-table
        :dense="true"
        :rows="dataSet"
        :columns="columnas"
        row-key="uuid"
        v-model:pagination="paginadoGenericoStore.filtros"
        :loading="loading"
        @request="onPaginar"
      >
        <!--------------------------------------
            loading
          ---------------------------------------->
        <template v-slot:loading>
          <Loading :showing="loading" />
        </template>

        <template v-slot:top-left>
          <div class="q-col-gutter-md row">
            <q-input
              dense
              placeholder="Buscar ..."
              v-model="paginadoGenericoStore.filtros.query"
              debounce="300"
            >
              <template v-slot:append>
                <q-icon name="search" />
              </template>
            </q-input>

            <q-btn color="green" flat label="Filtrar" @click="onRequest" />
            <q-btn color="blue" flat label="Reset" @click="onResetFiltros" />
          </div>
        </template>

        <template v-slot:body-cell-datos="props">
          <q-td :props="props">
            <q-list dense>
              <q-item>
                <q-item-section>Nombre</q-item-section>
                <q-item-section side> {{ props.row.nombre }}</q-item-section>
              </q-item>
              <q-item>
                <q-item-section>Tipo</q-item-section>
                <q-item-section side> {{ props.row.tipo }}</q-item-section>
              </q-item>
              <q-item>
                <q-item-section>Cron</q-item-section>
                <q-item-section side> {{ props.row.cron }}</q-item-section>
              </q-item>
            </q-list>
          </q-td>
        </template>

        <template v-slot:body-cell-ultimo="props">
          <q-td :props="props">
            <q-list dense>
              <q-item>
                <q-item-section>Inicio</q-item-section>
                <q-item-section side>
                  {{ props.row.last_started_at }}</q-item-section
                >
              </q-item>
              <q-item>
                <q-item-section>Finalizacion</q-item-section>
                <q-item-section side>
                  {{ props.row.last_finished_at }}</q-item-section
                >
              </q-item>
              <q-item>
                <q-item-section>Falla</q-item-section>
                <q-item-section side>
                  {{ props.row.last_failed_at }}</q-item-section
                >
              </q-item>
              <q-item>
                <q-item-section>Omitido</q-item-section>
                <q-item-section side>
                  {{ props.row.last_skipped_at }}</q-item-section
                >
              </q-item>
            </q-list>
          </q-td>
        </template>
      </q-table>
    </q-card>
  </q-page>
</template>

<script lang="ts">
import { defineComponent, onMounted, ref } from 'vue';
import { QTableProps } from 'quasar';
import { AxiosResponse } from 'axios';
import { api } from 'src/boot/axios/index';
import { usePaginadoGenericoStore } from 'src/stores/paginado-generico';
import Loading from 'src/components/Loading.vue';

// Defino las columnas de la tabla
const columnas: QTableProps['columns'] = [
  { name: 'datos', label: 'Datos', field: 'datos', align: 'left' },
  { name: 'ultimo', label: 'ultimo', field: 'ultimo', align: 'left' },
];

export default defineComponent({
  components: { Loading },
  name: 'ListadoPage',
  setup() {
    const loading = ref(true);
    const paginadoGenericoStore = usePaginadoGenericoStore();

    onMounted(() => {
      paginadoGenericoStore.$reset();
      onRequest();
    });

    ////////////////////////////////////////////////////////////////////////////////
    //            GESTION DE PAGINADO Y GESTION DE DATOS
    ////////////////////////////////////////////////////////////////////////////////
    /*********************************************
     *  Metodo onPaginar
     *  Gestiona la configuracion del paginado.
     */
    function onPaginar(props: QTableProps) {
      paginadoGenericoStore.setPaginar(props);
      onRequest();
    }

    function onFiltrar() {
      paginadoGenericoStore.filtroActivado = true;
      paginadoGenericoStore.filtros.page = 1; // siempre que vuelvo a filtra, vuelvo a la pagina 1.
      onRequest();
    }

    /*********************************************
     *  Metoto onRequest
     *  encargado de obtener los datos desde la API
     */
    const dataSet = ref([]);
    function onRequest() {
      loading.value = true;
      api
        .get('/api/administrador/jobs', {
          params: paginadoGenericoStore.parametros,
        })
        .then((response: AxiosResponse) => {
          paginadoGenericoStore.setRowTotal(response.data.count); // Actializo la cantidas de row, por si cambio
          dataSet.value = response.data;
          loading.value = false;
        })
        .catch(() => {
          loading.value = false;
        });
    }

    /*********************************************
     *  Metoto resetFiltros
     *  Reinilizo los Filtros
     */
    function onResetFiltros() {
      paginadoGenericoStore.resetFiltros();
      onRequest();
    }

    return {
      columnas,
      dataSet,
      paginadoGenericoStore,
      onRequest,
      onPaginar,
      onResetFiltros,
      onFiltrar,
      loading,
    };
  },
});
</script>
